config/routes.rb
AlteredBeast::Application.routes.draw do
  get '/session' => "sessions#create", :as => 'open_id_complete'

  resources :sites, :moderatorships, :monitorship

  resources :forums do
    resources :topics do
      resources :posts
      resource :monitorship
    end
    resources :posts
  end

  resources :posts do
    get :search, :on => :collection
  end
  resources :users do
    member do
      put :suspend, :make_admin, :unsuspend
      get :settings
      delete :purge
    end
    resources :posts, :only => [:index] do
#      get :monitored, :on => :collection, :shallow => true
    end
  end
  match '/users/:user_id/monitored(.:format)' => 'posts#monitored', :as => 'monitored_posts'

  match '/activate/:activation_code' => 'users#activate', :activation_code => nil, :as => 'activate'
  match '/signup' => 'users#new', :as => 'signup'
  match '/settings' => 'users#settings', :as => 'settings'
  match '/login' => 'sessions#new', :as => 'login'
  match '/logout' => 'sessions#destroy', :as => 'logout'
  match '/itex'  => 'itex#index'
  delete '/monitorship/:forum_id/:topic_id' => 'monitorships#destroy', :as => 'monitorship' 
  match '/monitorship/:forum_id/:topic_id' => 'monitorships#create', :as => 'monitorship' 

  resource  :session

  root :to => 'forums#index'
end

app/models/topic.rb
class Topic < ActiveRecord::Base
  include User::Editable

  before_validation :set_default_attributes, :on => :create

  after_create   :create_initial_post
  before_update  :check_for_moved_forum
  after_update   :set_post_forum_id
  before_destroy :count_user_posts_for_counter_cache
  after_destroy  :update_cached_forum_and_user_counts

  # creator of forum topic
  belongs_to :user

  # creator of recent post
  belongs_to :last_user, :class_name => "User"

  belongs_to :forum, :counter_cache => true

  # forum's site, set by callback
  belongs_to :site, :counter_cache => true

  has_many :posts,       :order => "#{Post.table_name}.created_at", :dependent => :delete_all
  has_one  :recent_post, :order => "#{Post.table_name}.created_at DESC", :class_name => "Post"
  
  has_many :voices, :through => :posts, :source => :user, :uniq => true
  
  has_many :monitorships, :dependent => :delete_all
  has_many :monitoring_users, :through => :monitorships, :source => :user, :conditions => {"#{Monitorship.table_name}.active" => true}
  
  validates_presence_of :user_id, :site_id, :forum_id, :title
  validates_presence_of :body, :on => :create

  attr_accessor :body
  attr_accessible :title, :body

  attr_readonly :posts_count, :hits

  has_permalink :title, :scope => :forum_id

  def to_s
    title
  end

  def sticky?
    sticky == 1
  end
  
  def hit!
    self.class.increment_counter :hits, id
  end

  def paged?
    posts_count > Post.per_page
  end

  def last_page
    [(posts_count.to_f / Post.per_page.to_f).ceil.to_i, 1].max
  end

  def post_number(post)
    self.posts.where("id <= #{post.id}").count
  end

  def post_page(post)
    [(post_number(post).to_f / Post.per_page.to_f).ceil.to_i, 1].max
  end

  def update_cached_post_fields(post)
    # these fields are not accessible to mass assignment
    if remaining_post = post.frozen? ? recent_post : post
      self.class.where(:id => id).update_all(:last_updated_at => remaining_post.created_at, :last_user_id => remaining_post.user_id, :last_post_id => remaining_post.id, :posts_count => posts.count)
    else
      destroy
    end
  end

  def to_param
    permalink
  end

  protected

    def create_initial_post
      user.reply self, @body # unless locked?
      @body = nil
    end

    def set_default_attributes
      self.site_id           = forum.site_id if forum_id
      self.sticky          ||= 0
      self.last_updated_at ||= Time.now.utc
    end

    def check_for_moved_forum
      old = Topic.find(id)
      @old_forum_id = old.forum_id if old.forum_id != forum_id
      true
    end

    def set_post_forum_id
      return unless @old_forum_id
      posts.update_all(:forum_id => forum_id)
      Forum.where(:id => @old_forum_id).update_all("posts_count = posts_count - #{posts_count}")
      Forum.where(:id => forum_id).update_all("posts_count = posts_count + #{posts_count}")
      Forum.where(:id => @old_forum_id).update_all("topics_count = topics_count - 1")
      Forum.where(:id => forum_id).update_all("topics_count = topics_count + 1")
    end

    def count_user_posts_for_counter_cache
      @user_posts = posts.group_by { |p| p.user_id }
    end

    def update_cached_forum_and_user_counts
      Forum.where(:id => forum_id).update_all("posts_count = posts_count - #{posts_count}")
      Site.where(:id => site_id).update_all("posts_count = posts_count - #{posts_count}")
      @user_posts.each do |user_id, posts|
        User.where(:id => user_id).update_all("posts_count = posts_count - #{posts.size}")
      end
    end
end

app/controllers/topics_controller.rb
class TopicsController < ApplicationController
  before_filter :find_forum
  before_filter :find_topic, :only => [:show, :edit, :update, :destroy]
  before_filter :admin_required, :only => [:edit, :update, :destroy]

  def index
    respond_to do |format|
      format.html { redirect_to forum_path(@forum) }
      format.xml  do
        @topics = find_forum.topics.paginate(:page => current_page)
        render :xml  => @topics
      end
    end
  end

  def edit
    set_content_type_header
  end

  def show
    respond_to do |format|
      if logged_in?
        current_user.seen!
        (session[:topics] ||= {})[@topic.id] = Time.now.utc
      end
      @topic.hit! unless logged_in? && @topic.user_id == current_user.id
      @posts = @topic.posts.paginate :page => current_page
      @post  = Post.new
      format.html { set_content_type_header }
      format.js
      format.xml  { render :xml  => @topic }
    end
  end

  def new
    @topic = @forum.topics.new

    respond_to do |format|
      format.html { set_content_type_header } # new.html.erb
      format.xml  { render :xml  => @topic }
    end
  end

  def create
    @topic = current_user.post @forum, params[:topic]

    respond_to do |format|
      if @topic.new_record?
        format.html { render :action => "new" }
        format.xml  { render :xml  => @topic.errors, :status => :unprocessable_entity }
      else
        flash[:notice] = 'Topic was successfully created.'
        format.html { redirect_to(forum_topic_path(@forum, @topic)) }
        format.xml  { render :xml  => @topic, :status => :created, :location => forum_topic_url(@forum, @topic) }
      end
    end
  end

  def update
    current_user.revise @topic, params[:topic]
    respond_to do |format|
      if @topic.errors.empty?
        flash[:notice] = 'Topic was successfully updated.'
        format.html { redirect_to(forum_topic_path(Forum.find(@topic.forum_id), @topic)) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml  => @topic.errors, :status => :unprocessable_entity }
      end
    end
  end

  def destroy
    @topic.destroy

    respond_to do |format|
      format.html { redirect_to(@forum) }
      format.xml  { head :ok }
    end
  end

  protected

    def find_forum
      @forum = current_site.forums.find_by_permalink!(params[:forum_id])
    end
  
    def find_topic
      @topic = @forum.topics.find_by_permalink!(params[:id])
    end
end

app/helpers/topics_helper.rb
module TopicsHelper
end

app/views/topics/_form.html.erb
<%= form.error_messages %>

<p>
  <label for="topic_title"><%= I18n.t('txt.views_topics.topic', :default => 'Name') %></label><br />
  <%= form.text_field :title, :onchange => "/*TopicForm.editNewTitle(this);*/", :class => "primary", :tabindex => 10 %>

  <%= for_moderators_of @forum do %>
    <%= hidden_field(:topic, :forum_id) %>
    <label style="margin-left:1em;">
    <%= form.check_box :sticky %> <%= I18n.t('txt.sticky', :default => 'sticky') %>
    </label>

    <label style="margin-left:1em;">
    <%= form.check_box :locked %> <%= I18n.t('txt.locked', :default => 'locked') %>
    </label>
  <% end %>
</p>

<% if @topic.new_record? %>
<p>
	<label for="topic_body"><%= I18n.t('txt.views_topics.body', :default => 'Body') %></label><br />
	<%= form.text_area :body, :rows => 12, :tabindex => 20 %>
</p>
<% elsif admin? && (forums = current_site.ordered_forums).length > 1 %>
<p id="topic_forum_id">
  <label for="topic_forum_id"><%= I18n.t('txt.forum', :default => 'Forum') %></label><br />
  <%= form.collection_select :forum_id, forums, :id, :name %>
</p>
<% end %>

app/views/topics/_posts_list.erb
<a id="<%= dom_id @posts.first %>">&#xA0;</a>

<%= will_paginate @posts %>
<table class="posts wide">
<% for post in @posts do %>
<% unless post == @posts.first %>
<tr class="spacer">
  <td colspan="2">
    <a id="<%= dom_id post %>">&#xA0;</a>
  </td>
</tr>
<% end %>
<tr class="post hentry" id="<%= dom_id post %>-row">
  <td class="author vcard">
    <div class="date">
      <a href="#<%= dom_id post %>" rel="bookmark">
      <abbr class="updated" title="<%= post.created_at.xmlschema %>">
      <%= I18n.t 'txt.post_age', :when => time_ago_in_words(post.created_at), :default => "posted %{when} ago" %>
      </abbr>
      </a>
    </div>

    <%= avatar_for post.user %>
    <span class="fn"><%= link_to truncate(post.user.display_name, :length => 15), user_path(post.user), :class => (post.user == @posts.first.user ? "threadauthor" : nil) %></span>
    <% if post.user.admin? || post.forum.moderators.include?(post.user) || !post.user.active? %>
    <span class="admin">
      <% if post.user.admin? %>
        <%= I18n.t 'txt.user_is_administrator', :default => 'Administator' %>
      <% elsif post.forum.moderators.include?(post.user) %>
        <%= I18n.t 'txt.user_is_moderator', :default => 'Moderator' %>
      <% elsif post.user.suspended? %>
        <%= post.user.state  %>
      <% end %>
    </span>
    <% end %>
    <span class="posts"><%= I18n.t 'txt.count_posts', :count => post.user.posts.size, :num => number_with_delimiter(post.user.posts.size) %></span>

    <%= edited_on_tag(post) %>
    <% if logged_in? && post.editable_by?(current_user) %>
    <p>
      <span class="edit">
        <%= ajax_spinner_for "edit-post-#{post.id}", "spinner_bounce.gif" %>
				<%= link_to I18n.t('txt.admin.edit_post', :default => 'Edit post'), edit_forum_topic_post_path(@forum, @topic, post), :class => 'utility' %>
      </span>
    </p>
    <% end %>


  </td>
  <td class="body entry-content" id="post-body-<%= post.id %>">

    <%= link_to_function image_tag('clearbits/comment.gif', :class => 'icon reply'), "$('reply').toggle()" if logged_in? && @posts.first == post %>

      <% if post.user.active? %>
        <%= post.body_html.html_safe %>
      <% else %>
        <p>(<% I18n.t 'txt.suspended_user_post', :default => 'This post has been removed' %>)</p>
      <% end %>
  </td>
</tr>

<% end %>
</table>
       
<%= will_paginate @posts %>
<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history && history.replaceState && $$('.pagination')) {
  $$('.pagination a').invoke('observe', 'click', function(){
      <%= p = {'page' => params[:page].to_i} if params[:page]
       modify_history('pushState', @topic.title, "#{@topic.permalink}.html", p) %>
  });
  $$('.pagination a').invoke('writeAttribute','data-remote');
  $$('.edit a.utility').invoke('writeAttribute','data-remote');
};
//--><!]]></script>

app/views/topics/edit.html.erb
<h1><%= I18n.t 'txt.views_topics.edit', :default => 'Edit Topic' %></h1>

<%= form_for [@forum, @topic] do |f| %>
  <%= render :partial => "form", :object => f %>
  <br />
  <%= submit_tag I18n.t('txt.save_changes', :default => 'Save changes') %> <%= I18n.t 'txt.or', :default => 'or' %> <%= link_to(I18n.t('txt.cancel', :default => 'Cancel'), forum_topic_path) %>
<% end %>

app/views/topics/new.html.erb
<div class="crumbs" xstyle="margin-top:1.1em;">
  <%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
  <%= link_to @forum.name, forum_path(@forum) %> <span class="arrow">&#x2192;</span>
</div>

<h1 id="new_topic"><%= I18n.t 'txt.new_topic', :default => 'New topic' %></h1>
<p class="subtitle"><%= I18n.t 'txt.by_user', :default => 'by %{user}', :user => current_user.display_name %></p>

<% content_for :right do %>
  <%= render :partial => "posts/formatting" %>
<% end %>

<%= form_for [@forum, @topic] do |f| %>
  <%= render :partial => "form", :object => f %>
  <%= submit_tag I18n.t('txt.post_topic', :default => 'Post topic') %>
<% end %>

<%= javascript_tag "$('topic_title').focus();" %>

app/views/topics/show.html.erb
<% @page_title = @topic.title %>
<% @monitoring = logged_in? && Monitorship.where(:user_id => current_user.id, :topic_id => @topic.id, :active => true).present? %>

<% content_for :right do %>

<h5><%= I18n.t 'txt.voices', :default => 'Voices' %></h5>
<ul class="flat talking">
<% @topic.voices.each do | user | %>
  <li><%= link_to user.display_name, user_path(user) %></li>
<% end %>
</ul>


<% end # right content %>

<% if logged_in? %>

<%= form_tag monitorship_path(@forum, @topic.id), :style => 'margin-top:0em; float:right;' do %>
<div>
  <input id="monitor_checkbox" type="checkbox" <%= "checked='checked'".html_safe if @monitoring %> 
    onclick="if (this.checked) {
      <%= remote_function :url => monitorship_path(@forum, @topic.id) %>;
      $('monitor_label').update('<%= I18n.t('txt.monitoring_topic', :default => 'Monitoring topic')%>');
    } else {
      <%= remote_function :url => monitorship_path(@forum, @topic.id), :method => :delete %>;
      $('monitor_label').update('<%= I18n.t('txt.monitor_topic', :default => 'Monitor topic')%>')
    }" />
  <label id="monitor_label" for="monitor_checkbox"><%= @monitoring ? I18n.t('txt.monitoring_topic', :default => 'Monitoring topic') : I18n.t('txt.monitor_topic', :default => 'Monitor topic') %></label>
  <%= hidden_field_tag '_method', 'delete' if @monitoring %>
  <%= submit_tag :Set, :id => 'monitor_submit' %>
</div>
<% end %>

<% end %>


<div class="crumbs">
  <%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
  <%= link_to @topic.forum.name, forum_path(@topic.forum) %> 
  <% 
  page=session[:forum_page] ? session[:forum_page][@topic.forum.id] : nil
  if page and page!=1 %>
  <small style="color:#ccc">
  (<%= link_to I18n.t('txt.page_nr', :default => 'page %{nr}'), forum_path(:id => @topic.forum, :page => page) %>)
  </small>
  <% end %>
  <span class="arrow">&#x2192;</span>
</div>

<h1 id="topic-title" style="margin-top:0.5em;"<%= %( onmouseover="$('topic_mod').show();" onmouseout="$('topic_mod').hide();").html_safe if logged_in? %>>

  <%= @topic.title %>
  <% if @topic.locked? %>
  <span>(<%= I18n.t 'txt.topic', :default => 'Topic' %> <%= I18n.t 'txt.locked', :default => 'locked' %>)</span>
  <% end %>
  <% if logged_in? %>
    <span style="display:none;" id="topic_mod">
      <% if @topic.editable_by?(current_user) %>
        <%= link_to(I18n.t('txt.edit', :default => 'edit'), edit_forum_topic_path(@forum, @topic), :class => "utility") %> |
        <%= link_to(I18n.t('txt.delete', :default => 'delete'), forum_topic_path(@forum, @topic), :class => "utility", :method => :delete, :confirm => I18n.t('txt.views_topics.delete_sure', :default => 'Delete this topic forever?')) %>
      <% end %>
    </span>
  <% end %>
</h1>

<p class="subtitle">
  <%= feed_icon_tag @topic.title, forum_topic_posts_path(@forum, @topic, :format => 'atom') %>
  <%= I18n.t 'txt.count_posts', :count => @topic.posts.size, :num => number_with_delimiter(@topic.posts.size) %>,
  <%= I18n.t 'txt.count_voices', :count => @topic.voices.size, :num => number_with_delimiter(@topic.voices.size) %>
</p>

<div id="posts_list">
<% unless @posts.empty? %>
  <%= render(:partial => 'posts_list') %>
<% end %>
</div>

<% if logged_in? %>
<div id="edit"></div>
<% if @topic.locked? %>
<p>
    <%= image_tag "clearbits/lock.gif", :class => "icon grey", :title => I18n.t('txt.views_topics.topic_locked', :default => "Topic locked") %> 
    <label>
    <%= I18n.t 'txt.views_topics.locked_topic', :default => 'This topic is locked.' %></label>
</p>
<% else %>

<p><%= link_to I18n.t('txt.reply_to_topic', :default => 'Reply to topic'), "#reply", :class => "utility", :id => 'reply-link' %></p>

<div id="reply" class="editbox">
<div class="container">
  <%= content_tag :p, flash[:bad_reply], :class => 'notice' if flash[:bad_reply] %>
  <%= form_for [@forum, @topic, @topic.posts.new] do |f| %>
  <table width="100%">
    <tr>
      <td rowspan="2" style="width: 70%">
        <%= f.text_area :body, :rows => 8 %>
      </td>
      <td valign="top">
        <%= render :partial => "posts/formatting" %>
      </td>
    </tr>
    <tr>
      <td valign="bottom" style="padding-bottom:15px;">
       <%= submit_tag I18n.t('txt.views_topics.save_reply', :default => 'Save reply') %> <span class="button_or"><%= I18n.t 'txt.or', :default => 'or' %> <%= link_to link_to(I18n.t('txt.cancel', :default => 'cancel'), '#', :id => 'reply-cancel') %></span>
     </td>
   </tr>
  </table>
  <% end %>
</div>
</div>
<% end %>
<% end %>

<div class="crumbs" style="margin-top:1.1em;">
  <%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
  <%= link_to @topic.forum.name, forum_path(@topic.forum) %> <span class="arrow">&#x2192;</span>
</div>

<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history  && history.replaceState && $$('.pagination')) {
  Event.observe(window, 'popstate', function(event){
    if(event.state) new Ajax.Request("<%= @topic.permalink %>", {method: 'get', parameters: event.state})
  });
};
//--><!]]></script>

app/views/topics/show.js.erb
$('posts_list').update("<%= escape_javascript(render(:partial => 'posts_list'))%>");
<%= p = {'page' => params[:page].to_i} if params[:page]
   modify_history('replaceState', @topic.title, "#{@topic.permalink}.html", p) %>